#include <chrono>
#include <iostream>
#include <thread>
#include <vector>

using namespace std;
using namespace std::chrono;

class Company {
	public:
		void finishProject() {
			vector<thread> workers;
			int numOfWorkers = thread::hardware_concurrency();
			for (int jobId = 0; jobId < numOfWorkers; ++jobId)
				workers.push_back(thread(&Company::doJob, this, jobId));

			for (thread& worker : workers)
				worker.join();

			cout<<"Project completed..."<<endl;
		}
	private:
		void doJob(int id) {
			this_thread::sleep_for(chrono::seconds((6*id+3) % 5));
			cout<<"The job "<<id<<" has been completed!"<<endl;
			// The result of the ,,job" can be saved to a private variable.
		}
};

int main()	{
	Company noname;
	noname.finishProject();
	return 0;
}

