#include <iostream>
#include <vector>
#include <thread>
#include <mutex>

#define COUNTER_TRESHOLD 100
#define COUNTER 0
#define HAMMER 1
#define SCREW_DRIVER 2
#define SAW 3
#define MUTEXES_COUNT 4
#define THREADS_COUNT 3
#define WORK_ITERATIONS 1000000

using namespace std;

struct argsStruct_t{
    mutex *counterMutex;
    int *counter;
    mutex *tool1;
    string tool1Name;
    mutex *tool2;
    string tool2Name;
    int threadID;
};

void work()
{
    for (int i = 0; i < WORK_ITERATIONS; i++);
}

void* guyThread(void *args)
{
    argsStruct_t *tool = (argsStruct_t *)args;
    while(true) {
    	{
	        unique_lock<mutex> tool1_lock(*tool->tool1);
	        cout << "Guy " <<tool->threadID << " borrowed " << tool->tool1Name << "." << endl;
	        work();
	        unique_lock<mutex> tool2_lock(*tool->tool2);
	        cout << "Guy " << tool->threadID << " borrowed " << tool->tool2Name << "." << endl;
	        work();
        }
        if ((*tool->counter) > COUNTER_TRESHOLD)
            break;
        {
        	unique_lock<mutex> counter_lock(*tool->counterMutex);
        	(*tool->counter)++;
        }
    }
    return 0;
}

int main() {
    vector<thread> threadGuys;
    vector<mutex> mutexes(MUTEXES_COUNT);
    int counter = 0;
    vector<argsStruct_t> threadTools(THREADS_COUNT);
    threadTools[0] = {&mutexes[COUNTER], &counter, &mutexes[HAMMER], "hammer", &mutexes[SCREW_DRIVER], "screw driver", 0};
    threadTools[1] = {&mutexes[COUNTER], &counter, &mutexes[SCREW_DRIVER], "screw driver", &mutexes[SAW], "saw", 1};
    threadTools[2] = {&mutexes[COUNTER], &counter, &mutexes[SAW], "saw", &mutexes[HAMMER], "hammer", 2};

    for(int i = 0; i < THREADS_COUNT; i++)
        threadGuys.push_back(thread(guyThread, (void *) &threadTools[i]));
    for(int i = 0; i < THREADS_COUNT; i++)
        threadGuys[i].join();
    return 0;
}
